<?php

/**
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* @package Xmap RealEstateManager
* @copyright (C) OrdaSoft - Andrey Kvasnevskiy
* @license GNU/GPL
* @description RealEstateManager XMap plugin for RealEstateManager Component
*/

defined('_JEXEC') or die ('Direct Access to this location is not allowed.');

$f_path = JPATH_SITE.'/'.'administrator'.'/'.'components'.'/'.'com_realestatemanager'.'/'.'functions.php';
if (!file_exists($f_path)){
    echo "You need to install RealEstateManager first<br />"; exit;
} else require_once($f_path);


class xmap_com_realestatemanager {
    var $orderby = 'title';

    function isOfType(&$xmap, &$parent){
        if (strpos($parent->link, 'option=com_realestatemanager')){
            $parent->name="RealEstateManager";
            $parent->option="com_realestatemanager"; 
            return true;
        }
        return false;
    }


    function &getTree(&$xmap, &$parent, &$params){
        global $mosConfig_absolute_path;
        $list = array();
        $parent->name="RealEstateManager";
        $parent->option="com_realestatemanager";
        $parent->uid="com_realestatemanager";

        $link_query = parse_url($parent->link);
        parse_str(html_entity_decode($link_query['query']), $link_vars);
        if (version_compare(JVERSION, "1.6.0", "lt")){
            $view = JArrayHelper::getValue($link_vars,'task','all_categories');
        } else if (version_compare(JVERSION, "1.6.0", "ge") && version_compare(JVERSION, "2.5.100", "lt")){
            $view = JArrayHelper::getValue($link_vars,'view','all_categories');
        }

        switch ($view){
            case 'all_categories':
                $catid = JArrayHelper::getValue($link_vars,'catid',0);
                xmap_com_realestatemanager::getCategoryTree($xmap, $parent, $catid, $params);
                break;

            case 'alone_category':
                if (version_compare(JVERSION, "1.6.0", "lt")){
                    if (strpos($parent->params, 'catid=')!==false){
                        $catid = substr($parent->params, strpos($parent->params,'=',0)+1, strpos($parent->params,'back',0)-strpos($parent->params,'=',0)-2);
                    }
                } else if (version_compare(JVERSION, "1.6.0", "ge") && version_compare(JVERSION, "2.5.100", "lt")){
                    $catid = ($parent->params->getValue('single_category'));
                }
                xmap_com_realestatemanager::singleCategoryHandler($xmap, $parent, $catid);
                break;

            case 'my_houses':
            case 'show_my_houses':
                xmap_com_realestatemanager::myHousesHandler($xmap, $parent);
                break;

            case 'owner_houses':
            case 'view_user_houses':
                if (version_compare(JVERSION, "1.6.0", "lt")){
                    if (strpos($parent->params, 'username=')!==false){
                        $username = substr($parent->params, strpos($parent->params,'=',0)+1, strpos($parent->params,'back',0)-strpos($parent->params,'=',0)-2);
                    }
                } else if (version_compare(JVERSION, "1.6.0", "ge") && version_compare(JVERSION, "2.5.100", "lt")){
                    $username = ($parent->params->getValue('username'));
                }
                xmap_com_realestatemanager::singleUserHousesHandler($xmap, $parent, $username);
                break;

            case 'owners_list':
                xmap_com_realestatemanager::ownersListHandler($xmap, $parent);
                break;

            default:
                break;
        }
        return $list;
    }


    function getRealEstateManager(&$xmap, &$parent, &$catid, &$params, $catid){
        $Itemid = $parent->id;
        $xmap->changeLevel(1);

        $database = &JFactory::getDBO();
        $s = getWhereUsergroupsCondition("c");

        $q = "SELECT h.id, h.htitle, hc.idcat
           \n FROM #__rem_houses AS h
           \n LEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id
           \n LEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
           \n WHERE (".$s.") AND h.published = '1' AND c.id=".$catid;
        $database->setQuery($q);
        $houses = $database->loadObjectList();

        foreach($houses as $house){
            $node = new stdclass;
            $node->id = $house->id;
            $node->uid = $house->id;
            $node->name = $house->htitle;
            $node->parent=1;
            $node->browsNav=1;//open new window
            $node->ordering=2;
            $node->priority=$parent->priority;
            $node->chansefreq=$parent->changefreq;
            $node->changefreq=$parent->changefreq;
            $node->modified= date("Y-m-d h:i:s");
            $node->type='component';
            $node->menutype='mainmenu';
            $node->link ='index.php?option=com_realestatemanager&amp;task=view&amp;catid='.$house->idcat.'&amp;id='.$house->id.'&amp;Itemid='.$Itemid;
            $xmap->printNode($node);
        }
        $xmap->changeLevel(-1);
    }


    function getCategoryTree(&$xmap, &$parent, &$catid, &$params){
//         xmap_com_realestatemanager::header();

        global $my,$mosConfig_absolute_path;

        $database = &JFactory::getDBO();
        $s = getWhereUsergroupsCondition("c");
        $q = "SELECT c.id, c.title, c.name as category, c.parent_id 
           \n FROM #__rem_main_categories AS c
           \n WHERE (".$s.") AND c.published = '1' AND c.section='com_realestatemanager'
           \n ORDER BY parent_id, ordering";
        $database->setQuery($q);
        $cats = $database->loadObjectList();

        xmap_com_realestatemanager::getSubCategory($xmap, $parent, $catid, $params, $catid, $cats);
    }


    function getSubCategory(&$xmap, &$parent, &$catid, &$params, $parentid, $cats){
        $link_query = parse_url($parent->link);
        parse_str( html_entity_decode($link_query['query']), $link_vars);
        $Itemid = $parent->id;

        $xmap->changeLevel(1);
        foreach($cats as $subcat){
            if($subcat->parent_id==$parentid){
                $node = new stdclass;
                $node->id = $parent->id;
                $node->uid=$parent->uid.'a'.$subcat->id;
                $node->name = $subcat->title;
                $node->parent=1;
                $node->browsNav=1;
                $node->ordering=2;
                $node->priority=$parent->priority;
                $node->chansefreq=$parent->changefreq;
                $node->changefreq=$parent->changefreq;
                $node->modified= date("Y-m-d h:i:s");
                $node->type='component';
                $node->link = 'index.php?option=com_realestatemanager&amp;task=showCategory&amp;catid='.$subcat->id.'&amp;Itemid='.$Itemid;
                $xmap->printNode($node);
                xmap_com_realestatemanager::getSubCategory($xmap, $parent, $catid ,$params,$subcat->id,$cats);
                xmap_com_realestatemanager::getRealEstateManager($xmap, $parent, $catid ,$params,$subcat->id);
            }
        }
        $xmap->changeLevel(-1);
    }


    function singleCategoryHandler(&$xmap, &$parent, &$catid){
        // The [Single Category] menu type handler
//         xmap_com_realestatemanager::header();
        $Itemid = $parent->id;
        $database = &JFactory::getDBO();
        $s = getWhereUsergroupsCondition("c");
        $query = "SELECT h.*,hc.idcat AS catid, c.title as category_titel
               \n FROM #__rem_houses AS h
               \n LEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id
               \n LEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
               \n WHERE hc.idcat = '".$catid."' AND h.published='1' AND h.approved='1'
               \n AND c.published='1' AND (".$s.")
               \n GROUP BY h.id";
        $database->setQuery($query);
        $items = $database->loadObjectList();

        $xmap->changeLevel(1);
        
        foreach ($items as $house)
            xmap_com_realestatemanager::printNode($xmap, $parent, $Itemid, $house->id, $house->htitle, $catid, $house->id, true);

        $q = "SELECT h.id AS id, h.htitle AS title, c.title AS category, c.parent_id, c.id AS catid 
              FROM #__rem_houses AS h
              LEFT JOIN #__rem_categories AS hc ON h.id=hc.iditem AND h.published=1 AND h.approved=1
              LEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
              WHERE (".$s.")
              AND c.published = '1' 
              GROUP BY c.id
              ORDER BY c.parent_id, c.ordering";
        $database->setQuery($q);
        $cats = $database->loadObjectList();

        xmap_com_realestatemanager::getSubCategory($xmap, $parent, $catid, $params, $catid, $cats);
        $xmap->changeLevel(-1);
    }


    function myHousesHandler(&$xmap, &$parent){
        // The [my houses] menu type handler
//         xmap_com_realestatemanager::header();
        $Itemid = $parent->id;
        $items = array();

        $my = &JFActory::getUser();
        if (!isset($my->name)) return;

        $database = &JFActory::getDBO();
        $s = getWhereUsergroupsCondition("c");
        $q = "SELECT h.htitle as title, h.id as id, c.id AS catid 
              FROM `#__rem_houses` AS h
              LEFT JOIN `#__users` AS u ON u.email=h.owneremail
              LEFT JOIN `#__rem_categories` AS hc ON hc.iditem=h.id
              LEFT JOIN `#__rem_main_categories` AS c ON hc.idcat=c.id
              WHERE h.owneremail = '".$my->email."'
              GROUP BY id";
        $database->setQuery($q);
        $items = $database->loadObjectList();

        $xmap->changeLevel(1);

        if (isset($items[0])) foreach ($items as $house)
            xmap_com_realestatemanager::printNode($xmap, $parent, $Itemid, $house->id, $house->title, $house->catid, $house->id, true);
        $xmap->changeLevel(-1);
    }


    function singleUserHousesHandler(&$xmap, &$parent, &$username){
        // The [Single User Houses] menu type handler
//         xmap_com_realestatemanager::header();
        $Itemid = $parent->id;
        $database = &JFactory::getDBO();
        $q = "SELECT h.*, c.id AS catid 
              FROM `#__rem_houses` AS h
              LEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id 
              LEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat 
              LEFT JOIN `#__users` AS u ON u.email=h.owneremail
              WHERE h.approved = 1 AND c.published = 1 AND h.published = 1 AND
              u.name='".$username."' 
              GROUP BY h.htitle";
        $database->setQuery($q);
        $items = $database->loadObjectList();
        $xmap->changeLevel(1);

        foreach ($items as $house)
            xmap_com_realestatemanager::printNode($xmap, $parent, $Itemid, $house->id, $house->htitle, $house->catid, $house->id, true);
        $xmap->changeLevel(-1);
    }


    function ownersListHandler (&$xmap, &$parent){
        // The [owners list] menu type handler
//         xmap_com_realestatemanager::header();
        $Itemid = $parent->id;
        $database = &JFactory::getDBO();
        $s = getWhereUsergroupsCondition("c");
        $items = "SELECT u.name, u.email, u.id, COUNT(h.owneremail)
               \n FROM #__rem_houses AS h
               \n LEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id
               \n LEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
               \n LEFT JOIN #__users AS u ON h.owneremail=u.email
               \n WHERE h.published=1 AND h.approved=1 AND h.owneremail!='' AND (".$s.")
               \n GROUP BY u.name
               \n ORDER BY u.name";
        $database->setQuery($items);
        $owners = $database->loadObjectList();
        $xmap->changeLevel(1);

        foreach($owners as $owner){
            xmap_com_realestatemanager::printNode($xmap, $parent, $Itemid, $owner->id, $owner->name, 0, 0, false, $owner->name);

            $q = "SELECT h.*, c.id AS catid FROM `#__rem_houses` AS h
                  LEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id
                  LEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
                  WHERE h.approved = 1 AND c.published = 1 AND h.published = 1 AND (".$s.") AND h.owneremail='".$owner->email."'
                  GROUP BY h.id";
            $database->setQuery($q);
            $houses = $database->loadObjectList();

            $xmap->changeLevel(1);

            foreach ($houses as $house)
                xmap_com_realestatemanager::printNode($xmap, $parent, $Itemid, $house->id, $house->htitle, $house->catid, $house->id, true);
            $xmap->changeLevel(-1);
        }
        $xmap->changeLevel(-1);
    }


//     function header(){
//         echo "<hr style='width:50%; color: #555;background-color:#555;border:0px none;height:1px;clear:both;' />";
//     }


    function printNode(&$xmap, &$parent, $Itemid, $node_uid, $node_name, $catid = 0, $houseid = 0, $is_house = false, $name = false){
        $node = new stdclass;
        $node->id = $Itemid; 
        $node->uid = $node_uid; 
        $node->name = $node_name;
        $node->parent = 1; 
        $node->browsNav = 1; 
        $node->ordering = 2; 
        $node->priority=$parent->priority;
        $node->chansefreq=$parent->changefreq;
        $node->changefreq=$parent->changefreq;
        $node->modified= date("Y-m-d h:i:s");
        $node->type = 'component'; 
        $node->menutype = 'mainmenu'; 
        if ($is_house) $node->link = 'index.php?option=com_realestatemanager&amp;task=view&amp;id='.$houseid.'&amp;catid='.$catid.'&amp;Itemid='.$Itemid;
            elseif ($catid > 0) $node->link = 'index.php?option=com_realestatemanager&amp;task=showcategory&amp;catid='.$catid.'&amp;Itemid='.$Itemid;
                elseif (isset($name) AND $name != '') $node->link = 'index.php?option=com_realestatemanager&amp;task=view_user_houses&amp;name='.$name.'&amp;Itemid='.$Itemid;
        $xmap->printNode($node);
    }
}
